local ILG = {};
_G.ILG = ILG;
local frame;

ILG.party = {};
ILG.party.n = 0;
ILG.party.member = {};
ILG.party.InstanceLevel = "";

ILG.partyReal = {}; -- the party that last longer than ILG.cfg.saveTime mins
ILG.partyReal.n = 0;
ILG.partyReal.member = {};
ILG.partyReal.InstanceLevel = "";

ILG.InstanceSwitched = true;
ILG.Active = false;
ILG.DisableEvent = false;
ILG.lastTime = 0;
ILG.elapsed = 0;
ILG.SwitchToRaid = false;
--ILG.tools = {};

ILG.cfg = {};
ILG.default = {
	saveTime = 60,
};

function ILG.p(input, ...)
	DEFAULT_CHAT_FRAME:AddMessage("|cff0099ff[ILG]:|r " .. tostring(input), ...);
end
function ILG.dp(input, ...)
	DEFAULT_CHAT_FRAME:AddMessage("|cff0099ff[ILG]|r [|cff0099ff" .. type(input) .. "|r]: |cff2bff00" .. tostring(input) .. "|r", ...);
end

function ILG.OnLoad(this)
	frame = this;
	frame:RegisterEvent("VARIABLES_LOADED");
	frame:RegisterEvent("SAVE_VARIABLES");
	frame:RegisterEvent("PARTY_MEMBER_CHANGED");
	frame:RegisterEvent("CHAT_MSG_SYSTEM");
	
	SaveVariables("InviteLastGroup_Settings");
end

function ILG.SwitchOn()
	frame:RegisterEvent("PARTY_MEMBER_CHANGED");
	frame:RegisterEvent("CHAT_MSG_SYSTEM");
	ILG.p("|cff00ff00Enabled!|r");
	UnitPopop_ShowMenu = ILG.UnitPopop_ShowMenu;
	ILG.PARTY_MEMBER_CHANGED();
end
function ILG.SwitchOff()
	frame:UnregisterEvent("PARTY_MEMBER_CHANGED");
	frame:UnregisterEvent("CHAT_MSG_SYSTEM");
	ILG.p("|cffff0000Disabled!|r");
	UnitPopop_ShowMenu = ILG.SAVEDUnitPopop_ShowMenu;
end

SLASH_InviteLastGroup1 = "/ILG";
SlashCmdList["InviteLastGroup"] = function(editBox, msg)
	local words = {};
	for arg in msg:gmatch("%a+") do
		words[#words + 1] = arg:lower();
	end
	-- No switch case lol
	if (words[1] == "inv") then
		ILG.InviteLastParty();
	elseif (words[1] == "destroy") then
		ILG.DestroyGroup();
	elseif (words[1] == "on") then
		ILG.SwitchOn();
	elseif (words[1] == "off") then
		ILG.SwitchOff();
	else
		ILG.p("Menu - available commands:\n/ILG inv - Invite last group\n/ILG destroy - Kick group\n/ILG on - Enable ILG\n/ILG off - Disable ILG");
	end
end

function ILG.OnEvent(event, arg1, arg2, arg3, arg4)
	if (ILG[event]) then
		ILG[event](arg1, arg2, arg3, arg4);
	end
end

function ILG.SAVE_VARIABLES()
	InviteLastGroup_Settings = ILG.cfg;
end

function ILG.VARIABLES_LOADED()
	ILG.cfg = InviteLastGroup_Settings or ILG.default;
	local addon = {
		name = "Invite Last Group",
		version = "v1.2",
		author = "chuckySTAR - Ingame chuckymage - PvE Laoch",
		description = "Invite your last group with just a single click!",
		icon = "interface/icons/emo_wave.dds",
		category = "Miscellaneous, Quests & Leveling, Tooltip",
		configFrame = nil,
		slashCommands = "/ILG",
		miniButton = nil,
		disableScript = ILG.SwitchOff,
		enableScript = ILG.SwitchOn,
	};
	if (AddonManager) then
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon);
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author);
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("[ILG] Invite Last Group Add-On " .. addon.version .. " loaded.", 0, 0.6, 1);
	ILG.PARTY_MEMBER_CHANGED(); -- event doesn't fire on startup
end

function ILG.PARTY_MEMBER_CHANGED()
	if (not ILG.DisableEvent) then
		local numParty = GetNumPartyMembers();
		local numRaid = GetNumRaidMembers();
		local unitId = "";
		local limit = 0;
		
		local elapsed = GetTime();
		-- For saving the "real group" and not the half cuz' of people who left party earlier
		if (elapsed - ILG.lastTime > ILG.cfg.saveTime and ILG.lastTime ~= 0 or (numParty == 0 and numRaid == 0 and ILG.partyReal.n == 0)) then
			-- cant copy the whole array o_O
			ILG.partyReal.n = ILG.party.n;
			ILG.partyReal.member = ILG.party.member;
			ILG.partyReal.InstanceLevel = ILG.party.InstanceLevel;
		end
		if (numParty == 0 and numRaid == 0) then
			frame:Show(); -- Zero Group bugs and bugs and bugs -_- ... whether to set ILG.Active = false.
		end
	
		if (numRaid >= 2) then
			unitId = "raid";
			limit = 36;
		elseif (numParty >= 2) then
			unitId = "party";
			limit = numParty - 1; -- Remove player
		end
		
		if (ILG.Active and numParty >= 2 and numRaid == 0 and ILG.SwitchToRaid and IsPartyLeader("player")) then
			ILG.SwitchToRaid = false;
			SwitchToRaid();
		end
		
		if (numRaid >= 2 or numParty >= 2) then
			if (ILG.party.InstanceLevel == "") then
				ILG.party.InstanceLevel = GetInstanceLevel();
			end
			
			if (ILG.Active and ILG.partyReal.InstanceLevel ~= "" and (IsPartyLeader("player") or IsRaidLeader("player")) and not ILG.InstanceSwitched) then
				SetInstanceLevel(ILG.partyReal.InstanceLevel);
				if (GetInstanceLevel() == ILG.partyReal.InstanceLevel) then
					ILG.InstanceSwitched = true;
				end
			end
			
			ILG.party.member = {};
			ILG.party.n = 0;
			for i = 1, limit do
				tempname = UnitName(unitId .. i);
				if (tempname ~= nil) then
					ILG.party.member[tempname] = {};
					ILG.party.member[tempname].status = 1;
					ILG.party.member[tempname].checked = true;
					ILG.party.member[tempname].index = i;
					ILG.party.member[tempname].switched = true;
					ILG.party.n = ILG.party.n + 1; -- key "n" is needed to get the number of elements in this array, cuz of the associative array gay shit -_-
					-- ILG.partyMember[tempname].checked = 1;
					
					-- ILG.partyMember[#ILG.partyMember + 1] = {["name"] = tempname,
																   -- ["status"] = 0};
				end
				if (ILG.partyReal.member[tempname]) then
					ILG.partyReal.member[tempname].status = 1;
				end
				if (ILG.party.n == numRaid or (numRaid == 0 and ILG.party.n == numParty)) then -- "performance"
					break;
				end
			end
			if (numParty >= 2) then -- add player
				ILG.party.n = ILG.party.n + 1;
			end
			ILG.lastTime = elapsed;
		else
			ILG.lastTime = 0;
		end
		if (ILG.Active and numRaid > 0 and IsRaidLeader("player")) then
			for key, value in pairs(ILG.partyReal.member) do
				if (ILG.party.member[key]) then
					if (not UnitIsRaidAssistant("raid" .. ILG.party.member[key].index)) then
						ILG.DisableEvent = true;
						SwithRaidAssistant(ILG.party.member[key].index, true); -- misspelling omg
					end
					if (ILG.party.member[key].index ~= value.index and not value.switched) then
						ILG.DisableEvent = true; -- need to disable event because "MoveRaidMember" executes this event. can't unregister PARTY_MEMBER_CHANGED cuz rom crashes -_-
						ILG.partyReal.member[key].switched = true;
						MoveRaidMember(ILG.party.member[key].index, value.index);
					end
				end
			end
			if (ILG.DisableEvent) then
				ILG.DisableEvent = false;
				-- ILG.PARTY_MEMBER_CHANGED(); -- refresh -> :S too fast -> rom freezes!
			end
		end
	end
end

function ILG.InviteLastParty()
	if ((GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) or IsRaidLeader("player") or IsRaidAssistant() or IsPartyLeader("player")) then
		local hasInvited = false;
		if (ILG.partyReal.n > 6) then
			ILG.SwitchToRaid = true;
		else
			ILG.SwitchToRaid = false;
		end
		
		for key, value in pairs(ILG.partyReal.member) do
			if (not InPartyByName(key) and not InRaidByName(key) and value.checked and key ~= UnitName("player")) then
				hasInvited = true;
				value.status = 2;
				value.switched = false;
				InviteByName(key);
			end
		end
		if (hasInvited) then
			if (ILG.partyReal.member[UnitName("player")] ~= nil) then -- player wont be added in party but in raids
				ILG.partyReal.member[UnitName("player")].switched = false; -- add player for switching in raid
			end
			ILG.InstanceSwitched = false;
			ILG.Active = true;
		end
		SetLootMethod("freeforall")
	else
		ILG.print("You can't invite, because you aren't party leader or assistant");
	end
	
end

function ILG.DestroyGroup()
	local numParty = GetNumPartyMembers();
	local numRaid = GetNumRaidMembers();
	local unitId = "";
	if (numRaid >= 2) then
		unitId = "raid";
		limit = 36;
	elseif (numParty >= 2) then
		unitId = "party";
		limit = numParty - 1;
	end
	if (IsRaidLeader("player") or IsPartyLeader("player")) then
		for i = 1, limit do
			if (UnitName(unitId .. i) ~= nil and UnitName(unitId .. i) ~= UnitName("player")) then
				UninviteFromParty(unitId .. i);
			end
		end
	else
		ILG.p("You haven't got rights to destroy the group, either you aren't in a group or you are not leader.");
	end
end

function ILG.CHAT_MSG_SYSTEM(msg)
	local match = string.match(msg, string.sub(string.gsub(TEXT("SYS_DECLINE_GROUP"), "%[%$VAR1%]", "(%%a+)"), 1, -2));
	if (match ~= nil) then
		local tbl = ILG.GetTable();
		if (tbl.member[match]) then
			tbl.member[match].status = 3;
		end
	end
	if (msg == TEXT("SYS_INSTANCE_LEVEL_EASY")) then
		ILG.party.InstanceLevel = "easy";
	elseif (msg == TEXT("SYS_INSTANCE_LEVEL_NORMAL")) then
		ILG.party.InstanceLevel = "normal";
	elseif (msg == TEXT("SYS_INSTANCE_LEVEL_HARD")) then
		ILG.party.InstanceLevel = "hard";
	end
end

function ILG.GetTable()
	if (ILG.partyReal.n > 0) then
		return ILG.partyReal;
	else
		return ILG.party;
	end
end

function ILG.Self_OnClick(this)
	if (this.value == "INVITE_LAST_GROUP_MEMBER") then
		local tbl = ILG.GetTable();
		tbl.member[this.arg1].checked = not tbl.member[this.arg1].checked;
	elseif (this.value == "INVITE_LAST_GROUP_DESTROY") then
		ILG.DestroyGroup();
	elseif (this.value:sub(1, -3) == "INVITE_LAST_GROUP_TIME") then
		ILG.cfg.saveTime = tonumber(this.value:sub(-1, -1)) * 60;
		ILG.p("Saving Groups after: " .. this.value:sub(-1, -1) .. " Minute(s).");
	end
end

ILG.SAVEDUnitPopop_ShowMenu = UnitPopop_ShowMenu;
function ILG.UnitPopop_ShowMenu(dropdownMenu, which, unit, name, userData)
	if (which == "SELF" and UIDROPDOWNMENU_MENU_LEVEL == 1) then
		info = {};
		info.text = "Invite last group [Click!]";
		info.value = "INVITE_LAST_GROUP";
		info.owner = which;
		info.func = ILG.InviteLastParty;
		info.notCheckable = 1;
		info.textR = 0;
		info.textG = 0.6;
		info.textB = 1;
		info.hasArrow = 1;
		
		UIDropDownMenu_AddButton(info);
	elseif (which == "SELF" and UIDROPDOWNMENU_MENU_LEVEL == 2) then
		if (UIDROPDOWNMENU_MENU_VALUE == "INVITE_LAST_GROUP") then
			info = {};
			info.value = "INVITE_LAST_GROUP_TIME";
			info.owner = "INVITE_LAST_GROUP";
			info.notCheckable = 1;
			info.hasArrow = 1;
			info.text = "Save Grp after";
			info.textR = 0;
			info.textG = 0.6;
			info.textB = 1;
			UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
			
			info = {};
			info.value = "INVITE_LAST_GROUP_DESTROY";
			info.owner = "INVITE_LAST_GROUP";
			info.func = ILG.Self_OnClick;
			info.notCheckable = 1;
			info.text = "Destroy Group";
			info.textR = 1;
			info.textG = 0;
			info.textB = 0;
			UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
			
			-- -- --
			
			info = {};
			info.value = "INVITE_LAST_GROUP_MEMBER";
			info.owner = "INVITE_LAST_GROUP";
			info.func = ILG.Self_OnClick;
			info.notCheckable = nil;
			info.keepShownOnClick = 1;
			
			local inParty = false;
			local tbl = ILG.GetTable();
			for key, value in pairs(tbl.member) do
				if (key ~= UnitName("player")) then
					info.text = key;
					info.arg1 = key;
					if (tbl.member[key].checked) then
						info.checked = 1;
					else
						info.checked = nil;
					end
					inParty = InPartyByName(key) or InRaidByName(key);
					if (inParty) then
						info.tooltipText = "|cff00ff00[in party]|r";
						info.textR = 0; info.textG = 1; info.textB = 0;
					elseif (value.status == 2) then
						info.tooltipText = "|cffffff00[invited]|r";
						info.textR = 1; info.textG = 1; info.textB = 0;
					elseif (value.status == 3) then
						info.tooltipText = "|cffff0000[refused]|r";
						info.textR = 1; info.textG = 0; info.textB = 0;
					elseif (not inParty) then
						info.tooltipText = "|cffffffff[not in party]|r";
						info.textR = 1; info.textG = 1; info.textB = 1;
					end
					
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
			return;
		end
	elseif (which == "SELF" and UIDROPDOWNMENU_MENU_LEVEL == 3) then
		if (UIDROPDOWNMENU_MENU_VALUE == "INVITE_LAST_GROUP_TIME") then
			info = {};
			info.value = "INVITE_LAST_GROUP_TIME_1";
			info.owner = "INVITE_LAST_GROUP_TIME";
			info.func = ILG.Self_OnClick;
			if (ILG.cfg.saveTime == 60) then
				info.checked = 1;
			end
			info.text = "1 Minute";
			UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
			info.checked = nil;
			--
			info.value = "INVITE_LAST_GROUP_TIME_2";
			if (ILG.cfg.saveTime == 120) then
				info.checked = 1;
			end
			info.text = "2 Minutes";
			UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
			info.checked = nil;
			--
			info.value = "INVITE_LAST_GROUP_TIME_3";
			if (ILG.cfg.saveTime == 180) then
				info.checked = 1;
			end
			info.text = "3 Minutes";
			UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
			info.checked = nil;
			return;
		end
	end
	ILG.SAVEDUnitPopop_ShowMenu(dropdownMenu, which, unit, name, userData);
end
UnitPopop_ShowMenu = ILG.UnitPopop_ShowMenu;

-- function ILG.tools.inTable(tbl, val)
    -- for key, value in pairs(tbl) do
        -- if (value == val) then
            -- return true;
        -- end
    -- end
    -- return false;
-- end

function ILG.OnUpdate(elapsed)
	ILG.elapsed = ILG.elapsed + elapsed;
	if (ILG.elapsed > 1) then
		frame:Hide();
		ILG.elapsed = 0;
		if (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) then
			ILG.Active = false;
		end
	end
end